<template lang="pug">
b-card( :title='$t("default.site_metadata")' )
	form.form( @submit.prevent='save' )
		b-meta( v-model='meta' :title='false' )
		.field
			.control
				b-button( node="button" type="primary" :loagin='pending' fullwidth ) {{$t("buttons.save")}}
</template>

<script setup>
	import BMeta from "@/components/meta/Form.vue"

	import { computed, onMounted, ref } from "vue"

	import { useSettingsStore } from "@/stores/settings"
	import { useToast } from "vue-toastification"
	import { useI18n } from "vue-i18n"

	const { t } = useI18n()
	const toast = useToast()
	const ss = useSettingsStore()

	const pending = ref(false)

	const meta = computed({
		get: () => ss.get("meta"),
		set: val => ss.settings["meta"] = val
	})

	const fetch = async () => {
		await ss.getSetting("meta")
	}

	const save = async () => {
		if (pending.value) return

		pending.value = true

		try {

			await ss.editSetting("meta", meta.value)
			await fetch()
			toast.success(t("default.changes_saved"))

		} catch(err) {
			console.error(err)
		}
		
		pending.value = false
	}

	onMounted(() => {
		if (!meta.value)
			fetch()
	})
</script>

<style lang="scss" scoped>

</style>